// Versione con output su display LCD 16x2


#include <LiquidCrystal.h> //inclusione della libreria LCD

// definizione dei pin
int ACS714 = A0; 
int partitore = A1;
int PS_Switch_On=7; // Variabile per gestione accensione alimentatore da Arduino
int PS_On = 0;      // Variabile per gestione accensione alimentatore da Arduino
int Led_Red = 11;
int Led_Green = 12;
int Buzzer = 10;

//definizione valori integer e float per calcolo valori corrente e tensione
int sensorValue = 0; 
int outputValue = 0;
float vout = 0.0;

float vref = 5.0; 
int valV = 0;
float volts = 0.0;
float R1 = 46220.0;   // !! Valore della resistenza R1 !!
float R2 = 9781.0;    // !! Valore della resistenza R2 !!
float corr = 0.99;    // Valore di correzione lettura tensione originale 0.982 OK


// Definizione dei pin LCD
int RS = 5;
int EN = 4;
int D7 = 0;
int D6 = 1;
int D5 = 2;
int D4 = 3;

// Inizializzazione libreria LCD

LiquidCrystal lcd(RS,EN,D4,D5,D6,D7);

void setup(){

  analogRead(ACS714);    // prima lettura analogica della corrente
  analogRead(partitore); // prima lettura analogica della tensione
  lcd.begin(16,2);       //inizializzazione lcd 16x2
  delay (10);

  // Test LCD

  lcd.print("Test OK") ; // messaggio di test
  delay(200); // pausa di visualizzazione

  lcd.clear(); // cancellazione display
  delay(10); // pausa per effettuazione operazione

  pinMode(Buzzer,OUTPUT);

  // PS_On = 1; // Variabile per accensione dell'alimentatore NON UTILIZZATA
  
}

void loop(){

// Calcolo media Corrente e Tensione su 100 campioni

float MediaCorrente = 0;
float MediaTensione = 0;

  for(int i = 0; i < 100; i++) {
    MediaCorrente = MediaCorrente + (.0262 * analogRead(ACS714) -13.51) / 100; // Correzione indicazione corrente : Era .0264

MediaTensione = MediaTensione + (analogRead(partitore));
vout = (MediaTensione*vref)/1024.0;    //Conversione del valore in di 
volts = (vout / (R2/(R1+R2)))*corr/100;  //Calcolo valore letto  
    
    delay(1);
  }

// Condizionamento valori mostrati sul display
// 0 se tensione < 1 V - 0 se corrente < 0.15 A

if (MediaCorrente < 0.15) MediaCorrente = 0.0;
if (volts < 0.99) volts = 0.0;

// Visualizza valori misurati
  
  lcd.setCursor(0,0);  //setta il cursore sulla prima linea display   
  lcd.print("VOLT: "); // scrive la parola VOLTS:
  lcd.print(volts,1);    // riporta il valore calcolato dei volts

  lcd.setCursor(0,1);  // setta il cursore sulla prima linea display 
  lcd.print("AMPS: "); //scrivi la parola AMPS:  
  
  lcd.print(MediaCorrente*3,1);     // riporta il valore calcolato degli ampere

// Accensione Led Rosso se tensione < 13 V o > 13,8 V altrimenti accende Led Verde

pinMode(Led_Red, OUTPUT);
pinMode(Led_Green, OUTPUT);

if (volts < 12.7)
{ 
  digitalWrite(Led_Red, HIGH);
  digitalWrite(Led_Green, LOW);  
}
else if (volts > 13.7)
{  
digitalWrite(Led_Red, HIGH);
digitalWrite(Led_Green, LOW);  
}
else
{  
digitalWrite(Led_Green, HIGH);
digitalWrite(Led_Red, LOW);  
}

// Attiva buzzer se la corrente misurata supera la soglia impostata (23 A)

if (MediaCorrente*3 > 23) 
{
// tone(Buzzer,1600,200);  // Eliminato tono di allarme corrente alta
}


// Accensione alimentatore INUTILIZZATA
 
  // pinMode(PS_Switch_On, OUTPUT); 
  // digitalWrite(PS_Switch_On, HIGH);
  
}   
